diff --git a/test/unit/packaging/packaging_static_test.rb b/test/unit/packaging/packaging_static_test.rb
new file mode 100644
index 000000000..b4646cdca
--- /dev/null
+++ b/test/unit/packaging/packaging_static_test.rb
@@ -0,0 +1,84 @@
+require "test_helper"
+require "open3"
+require "yaml"
+
+# Packaging sanity gates (U1/U3/U4/U5): shell scripts parse, the release
+# workflow is valid YAML with the expected matrix, the PKGBUILD carries the
+# required fields, and the bundle marker name matches what Hive::Channel
+# detects. These are static checks — the functional installer tests live in
+# test/unit/packaging/install_sh_test.rb.
+class PackagingStaticTest < Minitest::Test
+  include HiveTestHelper
+
+  REPO_ROOT = File.expand_path("../../..", __dir__)
+
+  def shell_scripts
+    [
+      "packaging/install.sh",
+      "packaging/build-bundle.sh",
+      "packaging/aur/generate-srcinfo.sh"
+    ].map { |rel| File.join(REPO_ROOT, rel) }
+  end
+
+  def test_all_shell_scripts_parse
+    shell_scripts.each do |path|
+      assert File.exist?(path), "#{path} must exist"
+      out, err, status = Open3.capture3("bash", "-n", path)
+      assert status.success?, "#{path} has bash syntax errors:\n#{err}"
+    end
+  end
+
+  def test_shell_scripts_are_executable
+    shell_scripts.each do |path|
+      assert File.executable?(path), "#{path} must be executable"
+    end
+  end
+
+  def test_release_workflow_is_valid_yaml_with_expected_matrix
+    path = File.join(REPO_ROOT, ".github", "workflows", "release.yml")
+    doc = YAML.safe_load(File.read(path), aliases: true)
+
+    assert_equal "release", doc["name"]
+    # YAML 1.1 parses a bare `on:` key as boolean true — handle both.
+    trigger = doc["on"] || doc[true]
+    assert_includes trigger.dig("push", "tags"), "v*"
+
+    matrix = doc.dig("jobs", "build", "strategy", "matrix", "include")
+    platforms = matrix.map { |job| job["platform"] }.sort
+    assert_equal %w[linux-x86_64-gnu macos-arm64 macos-x86_64], platforms
+
+    # Oldest-glibc rule: linux artifacts must build on ubuntu-22.04.
+    linux_job = matrix.find { |job| job["platform"] == "linux-x86_64-gnu" }
+    assert_equal "ubuntu-22.04", linux_job["os"],
+                 "linux bundles must build on the oldest tier-1 runner for glibc compat"
+  end
+
+  def test_pkgbuild_carries_required_fields
+    path = File.join(REPO_ROOT, "packaging", "aur", "PKGBUILD")
+    content = File.read(path)
+
+    assert_includes content, "pkgname=hive-bin"
+    assert_includes content, "provides=('hive')"
+    assert_includes content, "conflicts=('hive')"
+    assert_includes content, "arch=('x86_64')"
+    assert_includes content, "linux-x86_64-gnu"
+  end
+
+  def test_bundle_marker_matches_channel_detection
+    assert_equal Hive::Channel::BUNDLE_MARKER, ".hive-bundle"
+    # build-bundle.sh writes the marker the channel detector looks for.
+    builder = File.read(File.join(REPO_ROOT, "packaging", "build-bundle.sh"))
+    assert_includes builder, Hive::Channel::BUNDLE_MARKER
+  end
+
+  def test_homebrew_formula_is_valid_ruby_and_vendors_no_ruby_dep
+    path = File.join(REPO_ROOT, "packaging", "homebrew", "Formula", "hive.rb")
+    content = File.read(path)
+    # ruby -c via the syntax check in a subprocess (formula references
+    # Homebrew constants we don't have here, so full load is impossible).
+    out, err, status = Open3.capture3("ruby", "-c", path)
+    assert status.success?, "formula has Ruby syntax errors:\n#{err}"
+    refute_match(/depends_on "ruby"/, content,
+                 "formula must NOT depend on system ruby — the bundle vendors it")
+  end
+end
diff --git a/test/unit/service_test.rb b/test/unit/service_test.rb
new file mode 100644
index 000000000..e636f1a87
--- /dev/null
+++ b/test/unit/service_test.rb
@@ -0,0 +1,273 @@
+require "test_helper"
+require "hive/service"
+require "open3"
+
+# U6 of the packaging plan: OS service registration (launchd on macOS,
+# systemd --user on Linux) with stubbed backends — no real launchctl /
+# systemctl is ever invoked here.
+class ServiceTest < Minitest::Test
+  include HiveTestHelper
+
+  class FakeStatus
+    def initialize(success)
+      @success = success
+    end
+
+    def success?
+      @success
+    end
+  end
+
+  def ok_status = FakeStatus.new(true)
+  def failing_status = FakeStatus.new(false)
+
+  def runner_recording(recording, status: ok_status)
+    ->(argv) { recording << argv; [ "", "", status ] }
+  end
+
+  # ── platform detection ────────────────────────────────────────────────
+
+  def test_platform_is_none_or_a_known_backend
+    # The test container is Linux without systemd, but don't hard-fail on
+    # developer machines — just assert the closed set.
+    assert_includes [ :launchd, :systemd, :none ], Hive::Service.platform
+  end
+
+  # ── unit paths ────────────────────────────────────────────────────────
+
+  def test_unit_paths_per_platform
+    assert_equal "/Users/x/Library/LaunchAgents/dev.hive.daemon.plist",
+                 Hive::Service.unit_path(platform: :launchd, home: "/Users/x")
+    assert_equal "/home/x/.config/systemd/user/hive.service",
+                 Hive::Service.unit_path(platform: :systemd, home: "/home/x")
+    assert_nil Hive::Service.unit_path(platform: :none)
+  end
+
+  def test_installed_is_false_when_no_unit_file
+    with_tmp_dir do |dir|
+      refute Hive::Service.installed?(platform: :systemd, home: dir)
+    end
+  end
+
+  def test_installed_is_true_when_unit_file_exists
+    with_tmp_dir do |dir|
+      path = Hive::Service.unit_path(platform: :systemd, home: dir)
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+      assert Hive::Service.installed?(platform: :systemd, home: dir)
+    end
+  end
+
+  # ── rendering ─────────────────────────────────────────────────────────
+
+  def test_render_systemd_unit_references_hive_bin_and_is_valid_shape
+    unit = Hive::Service.render_unit(platform: :systemd, hive_bin: "/usr/local/bin/hive",
+                                     log_file: "/tmp/daemon.log")
+    assert_includes unit, "ExecStart=/usr/local/bin/hive daemon start"
+    assert_includes unit, "WantedBy=default.target"
+    assert_includes unit, "[Install]"
+  end
+
+  def test_render_launchd_plist_is_valid_xml_with_label
+    require "rexml/document"
+    plist = Hive::Service.render_unit(platform: :launchd, hive_bin: "/opt/hive/bin/hive",
+                                      log_file: "/tmp/daemon.log")
+    doc = REXML::Document.new(plist)
+    labels = doc.get_elements("//string").map(&:text)
+    assert_includes labels, "dev.hive.daemon"
+    assert_includes labels, "/opt/hive/bin/hive"
+    assert_includes labels, "daemon"
+    assert_includes labels, "start"
+  end
+
+  # ── install! ──────────────────────────────────────────────────────────
+
+  def test_install_systemd_writes_unit_and_enables_when_asked
+    with_tmp_dir do |home|
+      commands = []
+      out = StringIO.new
+      path = Hive::Service.install!(
+        enable_and_start: true, platform: :systemd, home: home,
+        hive_bin: "/usr/local/bin/hive", log_file: "/tmp/d.log",
+        runner: runner_recording(commands), output: out
+      )
+
+      assert_equal File.join(home, ".config/systemd/user/hive.service"), path
+      assert File.exist?(path)
+      assert_equal [
+        %w[systemctl --user daemon-reload],
+        %w[systemctl --user enable --now hive.service]
+      ], commands
+      assert_includes out.string, "registered + started"
+    end
+  end
+
+  def test_install_systemd_register_only_does_not_enable
+    with_tmp_dir do |home|
+      commands = []
+      out = StringIO.new
+      Hive::Service.install!(
+        enable_and_start: false, platform: :systemd, home: home,
+        hive_bin: "/usr/local/bin/hive", log_file: "/tmp/d.log",
+        runner: runner_recording(commands), output: out
+      )
+
+      assert_equal [ %w[systemctl --user daemon-reload] ], commands
+      assert_includes out.string, "registered (not enabled)"
+    end
+  end
+
+  def test_install_launchd_writes_plist_and_loads_when_enabled
+    with_tmp_dir do |home|
+      commands = []
+      out = StringIO.new
+      path = Hive::Service.install!(
+        enable_and_start: true, platform: :launchd, home: home,
+        hive_bin: "/opt/hive/bin/hive", log_file: "/tmp/d.log",
+        runner: runner_recording(commands), output: out
+      )
+
+      assert_equal File.join(home, "Library/LaunchAgents/dev.hive.daemon.plist"), path
+      assert_equal [
+        %w[launchctl unload -w] + [path],
+        %w[launchctl load -w] + [path]
+      ], commands
+    end
+  end
+
+  def test_install_is_idempotent_overwrites_unit_in_place
+    with_tmp_dir do |home|
+      runner = runner_recording([])
+      args = { enable_and_start: false, platform: :systemd, home: home,
+               hive_bin: "/usr/local/bin/hive", log_file: "/tmp/d.log",
+               runner: runner, output: StringIO.new }
+      Hive::Service.install!(**args)
+      Hive::Service.install!(**args)
+      assert File.exist?(File.join(home, ".config/systemd/user/hive.service"))
+    end
+  end
+
+  def test_install_none_platform_is_a_noop
+    assert_nil Hive::Service.install!(enable_and_start: true, platform: :none,
+                                      runner: ->(_argv) { raise "must not run" })
+  end
+
+  def test_install_backend_failure_warns_but_keeps_unit_file
+    with_tmp_dir do |home|
+      out = StringIO.new
+      failing = ->(argv) { argv; [ "", "boom", failing_status ] }
+      path = Hive::Service.install!(
+        enable_and_start: true, platform: :systemd, home: home,
+        hive_bin: "/usr/local/bin/hive", log_file: "/tmp/d.log",
+        runner: failing, output: out
+      )
+      assert File.exist?(path), "unit file must survive backend failure"
+      assert_includes out.string, "warning"
+      assert_includes out.string, "enable manually"
+    end
+  end
+
+  # ── remove! ───────────────────────────────────────────────────────────
+
+  def test_remove_systemd_disables_then_deletes_unit
+    with_tmp_dir do |home|
+      path = File.join(home, ".config/systemd/user/hive.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+
+      commands = []
+      removed = Hive::Service.remove!(platform: :systemd, home: home,
+                                      runner: runner_recording(commands), output: StringIO.new)
+
+      assert removed
+      refute File.exist?(path)
+      assert_includes commands, %w[systemctl --user disable --now hive.service]
+    end
+  end
+
+  def test_remove_is_idempotent_when_nothing_installed
+    with_tmp_dir do |home|
+      refute Hive::Service.remove!(platform: :systemd, home: home, output: StringIO.new)
+    end
+  end
+
+  def test_remove_survives_backend_failure
+    with_tmp_dir do |home|
+      path = File.join(home, ".config/systemd/user/hive.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+      failing = ->(argv) { argv; [ "", "", failing_status ] }
+      removed = Hive::Service.remove!(platform: :systemd, home: home,
+                                      runner: failing, output: StringIO.new)
+      assert removed, "file removal is the authoritative step; backend failure must not block it"
+      refute File.exist?(path)
+    end
+  end
+
+  # ── daemon delegation ─────────────────────────────────────────────────
+
+  def test_running_systemd_true_only_when_active
+    with_tmp_dir do |home|
+      path = File.join(home, ".config/systemd/user/hive.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+
+      active = ->(argv) { argv; [ "active\n", "", ok_status ] }
+      inactive = ->(argv) { argv; [ "inactive\n", "", ok_status ] }
+
+      assert Hive::Service.running?(platform: :systemd, home: home, runner: active)
+      refute Hive::Service.running?(platform: :systemd, home: home, runner: inactive)
+    end
+  end
+
+  def test_running_false_when_not_installed
+    with_tmp_dir do |home|
+      refute Hive::Service.running?(platform: :launchd, runner: ->(argv) { argv; [ "", "", ok_status ] })
+    end
+  end
+
+  def test_start_and_stop_delegate_to_service_manager
+    with_tmp_dir do |home|
+      path = File.join(home, ".config/systemd/user/hive.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+      commands = []
+      runner = runner_recording(commands)
+
+      assert Hive::Service.start!(platform: :systemd, home: home, runner: runner)
+      assert Hive::Service.stop!(platform: :systemd, home: home, runner: runner)
+      assert_includes commands, %w[systemctl --user start hive.service]
+      assert_includes commands, %w[systemctl --user stop hive.service]
+    end
+  end
+
+  def test_start_raises_service_error_on_failure
+    with_tmp_dir do |home|
+      path = File.join(home, ".config/systemd/user/hive.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "[Unit]\n")
+      failing = ->(argv) { argv; [ "", "unit not found", failing_status ] }
+      assert_raises(Hive::Service::ServiceError) do
+        Hive::Service.start!(platform: :systemd, home: home, runner: failing)
+      end
+    end
+  end
+
+  # ── skip flag ─────────────────────────────────────────────────────────
+
+  def test_skipped_flag_honoured
+    old = ENV["HIVE_SKIP_SERVICE_REGISTRATION"]
+    begin
+      ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = "1"
+      assert Hive::Service.skipped?
+      ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = "0"
+      refute Hive::Service.skipped?
+    ensure
+      if old.nil?
+        ENV.delete("HIVE_SKIP_SERVICE_REGISTRATION")
+      else
+        ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = old
+      end
+    end
+  end
+end
